'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('zent-utils/classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _omit = require('zent-utils/lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = (_temp = _class = function (_Component) {
  _inherits(Button, _Component);

  function Button(props) {
    _classCallCheck(this, Button);

    var _this = _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).call(this, props));

    _this.handleClick = _this.handleClick.bind(_this);
    return _this;
  }

  // 处理点击事件


  _createClass(Button, [{
    key: 'handleClick',
    value: function handleClick(event) {
      if (this.props.disabled || this.props.loading) return;

      if (this.props.onClick) {
        this.props.onClick(event);
      }
    }

    // render a 标签

  }, {
    key: 'renderLink',
    value: function renderLink(classNames) {
      var Node = this.props.component || 'a';
      var disabled = this.props.disabled || this.props.loading;

      var _props = this.props,
          _props$href = _props.href,
          href = _props$href === undefined ? '' : _props$href,
          target = _props.target,
          others = _objectWithoutProperties(_props, ['href', 'target']);

      delete others.type;
      delete others.prefix;
      var attributes = _extends({}, others, {
        href: href,
        target: target
      });
      if (disabled) {
        delete attributes.href;
        delete attributes.target;
      }

      return _react2['default'].createElement(
        Node,
        _extends({}, attributes, {
          className: classNames,
          onClick: this.handleClick
        }),
        this.props.children
      );
    }

    // render button 标签

  }, {
    key: 'renderButton',
    value: function renderButton(classNames) {
      var Node = this.props.component || 'button';
      var disabled = this.props.disabled || this.props.loading;
      var nodeProps = (0, _omit2['default'])(this.props, ['type', 'size', 'className', 'block', 'component', 'disabled', 'loading', 'outline', 'bordered', 'prefix']);

      return _react2['default'].createElement(
        Node,
        _extends({}, nodeProps, {
          className: classNames,
          disabled: disabled,
          onClick: this.handleClick
        }),
        this.props.children
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _setClass;

      var renderer = this.props.href || this.props.target ? 'renderLink' : 'renderButton';
      var _props2 = this.props,
          className = _props2.className,
          type = _props2.type,
          size = _props2.size,
          block = _props2.block,
          disabled = _props2.disabled,
          loading = _props2.loading,
          outline = _props2.outline,
          bordered = _props2.bordered,
          prefix = _props2.prefix;

      var classNames = (0, _classnames2['default'])((_setClass = {}, _defineProperty(_setClass, prefix + '-btn-' + type + (outline ? '-outline' : ''), type !== 'default'), _defineProperty(_setClass, prefix + '-btn-' + size, size !== 'medium'), _defineProperty(_setClass, prefix + '-btn-block', block), _defineProperty(_setClass, prefix + '-btn-loading', loading), _defineProperty(_setClass, prefix + '-btn-disabled', disabled), _defineProperty(_setClass, prefix + '-btn-border-transparent', !bordered), _setClass), prefix + '-btn', className);

      return this[renderer](classNames);
    }
  }]);

  return Button;
}(_react.Component), _class.propTypes = {
  type: _react2['default'].PropTypes.oneOf(['default', 'primary', 'success', 'danger', 'link']),
  size: _react2['default'].PropTypes.oneOf(['large', 'medium', 'small']),
  className: _react2['default'].PropTypes.string,
  block: _react2['default'].PropTypes.bool,
  component: _react2['default'].PropTypes.string,
  disabled: _react2['default'].PropTypes.bool,
  loading: _react2['default'].PropTypes.bool,
  outline: _react2['default'].PropTypes.bool,
  bordered: _react2['default'].PropTypes.bool,
  prefix: _react2['default'].PropTypes.string
}, _class.defaultProps = {
  type: 'default',
  size: 'medium',
  className: '',
  block: false,
  disabled: false,
  loading: false,
  outline: false,
  bordered: true,
  prefix: 'zent'
}, _temp);
exports['default'] = Button;
module.exports = exports['default'];