'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('zent-utils/classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Checkbox = (_temp2 = _class = function (_Component) {
  _inherits(Checkbox, _Component);

  function Checkbox() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Checkbox);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Checkbox.__proto__ || Object.getPrototypeOf(Checkbox)).call.apply(_ref, [this].concat(args))), _this), _this.onChange = function (evt) {
      var props = _this.props;

      props.onChange({
        target: _extends({}, props, {
          type: 'checkbox',
          checked: evt.target.checked
        }),

        preventDefault: function preventDefault() {
          evt.preventDefault();
        },
        stopPropagation: function stopPropagation() {
          evt.stopPropagation();
        }
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Checkbox, [{
    key: 'render',
    value: function render() {
      var _classNames;

      var _props = this.props,
          checked = _props.checked,
          className = _props.className,
          style = _props.style,
          prefix = _props.prefix,
          disabled = _props.disabled,
          readOnly = _props.readOnly,
          children = _props.children,
          indeterminate = _props.indeterminate,
          value = _props.value,
          others = _objectWithoutProperties(_props, ['checked', 'className', 'style', 'prefix', 'disabled', 'readOnly', 'children', 'indeterminate', 'value']);

      var classString = (0, _classnames2['default'])((_classNames = {}, _defineProperty(_classNames, className, !!className), _defineProperty(_classNames, prefix + '-checkbox-wrap', true), _defineProperty(_classNames, prefix + '-checkbox-checked', !!checked), _defineProperty(_classNames, prefix + '-checkbox-disabled', disabled || readOnly), _defineProperty(_classNames, prefix + '-checkbox-indeterminate', indeterminate), _classNames));

      return _react2['default'].createElement(
        'label',
        { className: classString, style: style },
        _react2['default'].createElement(
          'span',
          { className: prefix + '-checkbox' },
          _react2['default'].createElement('span', { className: prefix + '-checkbox-inner' }),
          _react2['default'].createElement('input', _extends({}, others, {
            type: 'checkbox',
            checked: checked && !indeterminate,
            disabled: disabled,
            readOnly: readOnly,
            onChange: this.onChange
          }))
        ),
        children !== undefined ? _react2['default'].createElement(
          'span',
          null,
          children
        ) : null
      );
    }
  }]);

  return Checkbox;
}(_react.Component), _class.propTypes = {
  checked: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.number, _react2['default'].PropTypes.bool]),
  disabled: _react2['default'].PropTypes.bool,
  readOnly: _react2['default'].PropTypes.bool,
  indeterminate: _react2['default'].PropTypes.bool,
  onChange: _react2['default'].PropTypes.func,
  className: _react2['default'].PropTypes.string,
  style: _react2['default'].PropTypes.object,
  prefix: _react2['default'].PropTypes.string
}, _class.defaultProps = {
  prefix: 'zent',
  className: '',
  style: {},
  onChange: function onChange() {}
}, _temp2);
exports['default'] = Checkbox;
module.exports = exports['default'];