'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('zent-utils/classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _TimePanel = require('./time/TimePanel');

var _TimePanel2 = _interopRequireDefault(_TimePanel);

var _PanelFooter = require('./common/PanelFooter');

var _PanelFooter2 = _interopRequireDefault(_PanelFooter);

var _format = require('./utils/format');

var _clickOutside = require('./utils/clickOutside');

var _clickOutside2 = _interopRequireDefault(_clickOutside);

var _constants = require('./constants/');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TimePicker = (_temp = _class = function (_Component) {
  _inherits(TimePicker, _Component);

  function TimePicker(props) {
    _classCallCheck(this, TimePicker);

    var _this = _possibleConstructorReturn(this, (TimePicker.__proto__ || Object.getPrototypeOf(TimePicker)).call(this, props));

    _this.clickOutside = function (e) {
      if (!_this.picker.contains(e.target)) {
        _this.setState({
          openPanel: false
        });
      }
    };

    _this.onChangeTime = function (val) {
      _this.setState({
        actived: val
      });
    };

    _this.onSelectCurrent = function () {
      _this.setState({
        actived: new Date()
      });
    };

    _this.onClickInput = function () {
      _this.setState({
        openPanel: !_this.state.openPanel
      });
    };

    _this.onConfirm = function () {
      var value = (0, _format.formatDate)(_this.state.actived, _this.props.format);
      _this.setState({
        value: value,
        openPanel: false,
        showPlaceholder: false
      });
      _this.props.onChange(value);
    };

    var showPlaceholder = void 0;
    var selected = void 0;
    if (props.value) {
      showPlaceholder = false;
      selected = new Date(props.value);
    } else {
      showPlaceholder = true;
      selected = new Date();
    }
    _this.state = {
      value: (0, _format.formatDate)(selected, props.format),
      actived: selected,
      selected: selected,
      openPanel: false,
      showPlaceholder: showPlaceholder
    };
    return _this;
  }

  _createClass(TimePicker, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var state = this.state;
      var props = this.props;
      var prefixCls = props.prefix + '-datetime-picker ' + props.className;
      var inputCls = (0, _classnames2['default'])({
        'picker-input': true,
        'picker-input--empty': state.showPlaceholder
      });
      var timePicker = void 0;
      if (state.openPanel) {
        timePicker = _react2['default'].createElement(
          'div',
          { className: 'time-picker' },
          _react2['default'].createElement(_TimePanel2['default'], {
            actived: state.actived,
            format: props.format,
            disabledTime: props.disabledTime(),
            onChange: this.onChangeTime
          }),
          _react2['default'].createElement(_PanelFooter2['default'], {
            linkText: '\u6B64\u523B',
            linkCls: 'link--current',
            onClickLink: this.onSelectCurrent,
            onClickButton: this.onConfirm
          })
        );
      }
      return _react2['default'].createElement(
        'div',
        { className: prefixCls, ref: function ref(_ref) {
            return _this2.picker = _ref;
          } },
        _react2['default'].createElement(
          'div',
          { className: 'picker-wrapper' },
          _react2['default'].createElement(
            'div',
            { className: inputCls, onClick: this.onClickInput },
            state.showPlaceholder ? props.placeholder : state.value
          ),
          state.openPanel ? timePicker : ''
        )
      );
    }
  }]);

  return TimePicker;
}(_react.Component), _class.defaultProps = _constants.TIME_PROPS, _temp);
exports['default'] = (0, _clickOutside2['default'])(TimePicker);
module.exports = exports['default'];