'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('../utils/');

var _classnames = require('zent-utils/classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _PanelCell = require('../common/PanelCell');

var _PanelCell2 = _interopRequireDefault(_PanelCell);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ROW = 6;
var COL = 7;

var DatePanelBody = function (_Component) {
  _inherits(DatePanelBody, _Component);

  function DatePanelBody() {
    _classCallCheck(this, DatePanelBody);

    return _possibleConstructorReturn(this, (DatePanelBody.__proto__ || Object.getPrototypeOf(DatePanelBody)).apply(this, arguments));
  }

  _createClass(DatePanelBody, [{
    key: 'isSelected',
    value: function isSelected(val) {
      if (!this.props.selected) {
        return false;
      }
      var selectedDate = this.props.selected;
      if (Array.isArray(selectedDate)) {
        var _ret = function () {
          var i = 0;
          selectedDate.forEach(function (item) {
            (0, _utils.isSameDate)(val, item) ? i++ : '';
          });
          return {
            v: i > 0
          };
        }();

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
      }
      return (0, _utils.isSameDate)(val, selectedDate);
    }
  }, {
    key: 'isInRange',
    value: function isInRange(val) {
      var range = this.props.range;

      if (Array.isArray(range) && range[0] && range[1]) {
        if (val > range[0] && val < range[1]) {
          return true;
        }
      }
      return false;
    }
  }, {
    key: 'days',
    value: function days() {
      var props = this.props;
      var days = [];
      var index = 0;
      var copy = new Date(props.actived.getFullYear(), props.actived.getMonth(), props.actived.getDate());
      var firstDay = new Date(copy.setDate(1));
      var diff = parseInt(firstDay.getDay(), 10);
      for (var rowIndex = 0; rowIndex < ROW; rowIndex++) {
        days[rowIndex] = [];
        for (var colIndex = 0; colIndex < COL; colIndex++) {
          var val = (0, _utils.goDays)(firstDay, index - diff);
          var isBefore = (0, _utils.isBeforeMonth)(val, props.actived);
          var isAfter = (0, _utils.isAfterMonth)(val, props.actived);
          var isCurrent = (0, _utils.isSameDate)(val, _utils.CURRENT);
          var isDisabled = props.disabledDate(val);
          var isSelected = this.isSelected(val);
          var isInRange = this.isInRange(val);
          var className = (0, _classnames2['default'])({
            'panel__cell date-panel__cell': true,
            'panel__cell--different': isBefore || isAfter,
            'panel__cell--current': !isDisabled && isCurrent,
            'panel__cell--disabled': isDisabled,
            'panel__cell--selected': isSelected,
            'panel__cell--in-range': isInRange
          });
          days[rowIndex][colIndex] = {
            text: val.getDate(),
            value: val,
            isDisabled: isDisabled,
            className: className
          };
          index++;
        }
      }
      return days;
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;
      var days = this.days();
      return _react2['default'].createElement(
        'table',
        { className: 'date-table panel__table' },
        _react2['default'].createElement(
          'thead',
          null,
          _react2['default'].createElement(
            'tr',
            null,
            _react2['default'].createElement(
              'th',
              null,
              '\u65E5'
            ),
            _react2['default'].createElement(
              'th',
              null,
              '\u4E00'
            ),
            _react2['default'].createElement(
              'th',
              null,
              '\u4E8C'
            ),
            _react2['default'].createElement(
              'th',
              null,
              '\u4E09'
            ),
            _react2['default'].createElement(
              'th',
              null,
              '\u56DB'
            ),
            _react2['default'].createElement(
              'th',
              null,
              '\u4E94'
            ),
            _react2['default'].createElement(
              'th',
              null,
              '\u516D'
            )
          )
        ),
        _react2['default'].createElement(_PanelCell2['default'], { onSelect: props.onSelect, onHover: props.onHover, cells: days })
      );
    }
  }]);

  return DatePanelBody;
}(_react.Component);

exports['default'] = DatePanelBody;
module.exports = exports['default'];