'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('../utils');

var _HourPanel = require('./HourPanel');

var _HourPanel2 = _interopRequireDefault(_HourPanel);

var _MinutePanel = require('./MinutePanel');

var _MinutePanel2 = _interopRequireDefault(_MinutePanel);

var _SecondPanel = require('./SecondPanel');

var _SecondPanel2 = _interopRequireDefault(_SecondPanel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function noop() {}

var stateMap = {
  hour: 'openHour',
  minute: 'openMinute',
  second: 'openSecond'
};

var TimePanel = (_temp = _class = function (_Component) {
  _inherits(TimePanel, _Component);

  function TimePanel(props) {
    _classCallCheck(this, TimePanel);

    var _this = _possibleConstructorReturn(this, (TimePanel.__proto__ || Object.getPrototypeOf(TimePanel)).call(this, props));

    _this.onSelectHour = function (val) {
      var time = new Date(_this.state.time);
      time.setHours(val);
      _this.setState({
        openHour: false,
        time: time
      });
      _this.props.onChange(time);
    };

    _this.onSelectMinute = function (val) {
      var time = new Date(_this.state.time);
      time.setMinutes(val);
      _this.setState({
        openMinute: false,
        time: time
      });
      _this.props.onChange(time);
    };

    _this.onSelectSecond = function (val) {
      var time = new Date(_this.state.time);
      time.setSeconds(val);
      _this.setState({
        openSecond: false,
        time: time
      });
      _this.props.onChange(time);
    };

    _this.openHour = function () {
      _this.setState({
        openHour: true
      });
    };

    _this.openMinute = function () {
      _this.setState({
        openMinute: true
      });
    };

    _this.openSecond = function () {
      _this.setState({
        openSecond: true
      });
    };

    _this.hidePanel = function (type) {
      var key = stateMap[type];
      _this.setState(_defineProperty({}, key, false));
    };

    _this.state = {
      openHour: false,
      openMinute: false,
      openSecond: false,
      time: props.actived
    };
    return _this;
  }

  _createClass(TimePanel, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(next) {
      if ('actived' in next) {
        this.setState({
          time: next.actived
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state,
          time = _state.time,
          openHour = _state.openHour,
          openMinute = _state.openMinute,
          openSecond = _state.openSecond;

      var disabledTime = this.props.disabledTime || {};
      return _react2['default'].createElement(
        'div',
        { className: 'time-panel' },
        openHour ? _react2['default'].createElement(_HourPanel2['default'], { disabledHour: disabledTime.disabledHour, onSelect: this.onSelectHour, selected: time, hidePanel: this.hidePanel }) : null,
        openMinute ? _react2['default'].createElement(_MinutePanel2['default'], { disabledMinute: disabledTime.disabledMinute, onSelect: this.onSelectMinute, selected: time, hidePanel: this.hidePanel }) : null,
        openSecond ? _react2['default'].createElement(_SecondPanel2['default'], { disabledSecond: disabledTime.disabledSecond, onSelect: this.onSelectSecond, selected: time, hidePanel: this.hidePanel }) : null,
        _react2['default'].createElement(
          'div',
          { className: 'time-panel__preview' },
          _react2['default'].createElement(
            'span',
            { className: 'time__number', onClick: this.openHour },
            (0, _utils.padLeft)(time.getHours())
          ),
          _react2['default'].createElement(
            'span',
            { className: 'time__diliver' },
            ':'
          ),
          _react2['default'].createElement(
            'span',
            { className: 'time__number', onClick: this.openMinute },
            (0, _utils.padLeft)(time.getMinutes())
          ),
          _react2['default'].createElement(
            'span',
            { className: 'time__diliver' },
            ':'
          ),
          _react2['default'].createElement(
            'span',
            { className: 'time__number', onClick: this.openSecond },
            (0, _utils.padLeft)(time.getSeconds())
          )
        )
      );
    }
  }]);

  return TimePanel;
}(_react.Component), _class.defaultProps = {
  onChange: noop
}, _temp);
exports['default'] = TimePanel;
module.exports = exports['default'];