'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var CURRENT = exports.CURRENT = new Date();
var CURRENT_DAY = exports.CURRENT_DAY = new Date(CURRENT.getFullYear(), CURRENT.getMonth(), CURRENT.getDate());
var CURRENT_YEAR = exports.CURRENT_YEAR = CURRENT.getFullYear();
var CURRENT_MONTH = exports.CURRENT_MONTH = CURRENT.getMonth();
var CURRENT_DATE = exports.CURRENT_DATE = CURRENT.getDate();
var ONEDAY = exports.ONEDAY = 24 * 60 * 60 * 1000;

var padLeft = exports.padLeft = function padLeft(val) {
  return val < 10 ? '0' + val : val;
};

var getMonthStr = exports.getMonthStr = function getMonthStr(val) {
  return val.getFullYear() + '-' + padLeft(val.getMonth() + 1);
};

var getDateStr = exports.getDateStr = function getDateStr(val) {
  return val.getFullYear() + '-' + padLeft(val.getMonth() + 1) + '-' + val.getDate();
};

var isSameDate = exports.isSameDate = function isSameDate(val, cmp) {
  return val.getFullYear() === cmp.getFullYear() && val.getMonth() === cmp.getMonth() && val.getDate() === cmp.getDate();
};

var isCurrentMonth = exports.isCurrentMonth = function isCurrentMonth(val) {
  return val.getMonth() === CURRENT_MONTH;
};

var isBeforeMonth = exports.isBeforeMonth = function isBeforeMonth(val, cpr) {
  if (val.getFullYear() < cpr.getFullYear()) {
    return true;
  }
  return val.getFullYear() === cpr.getFullYear() && val.getMonth() < cpr.getMonth();
};

var isAfterMonth = exports.isAfterMonth = function isAfterMonth(val, cpr) {
  if (val.getFullYear() > cpr.getFullYear()) {
    return true;
  }
  return val.getFullYear() === cpr.getFullYear() && val.getMonth() > cpr.getMonth();
};

var goDays = exports.goDays = function goDays(val, diff) {
  return new Date(val.getTime() + diff * ONEDAY);
};

var goMonths = exports.goMonths = function goMonths(val, diff) {
  var cp = new Date(val);
  return new Date(cp.setMonth(cp.getMonth() + diff));
};

var goYears = exports.goYears = function goYears(val, diff) {
  var cp = new Date(val);
  return new Date(cp.setFullYear(cp.getFullYear() + diff));
};

var isArray = exports.isArray = function isArray(val) {
  return Array.isArray(val);
};

var isFunction = exports.isFunction = function isFunction(val) {
  return Object.prototype.toString.call(val) === '[object Function]';
};