'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _zentPortal = require('zent-portal');

var _zentPortal2 = _interopRequireDefault(_zentPortal);

var _DialogEl = require('./DialogEl');

var _DialogEl2 = _interopRequireDefault(_DialogEl);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DialogPortal = (0, _zentPortal.withNonScrollable)(_zentPortal2['default']);
var DialogPortalESCToClose = (0, _zentPortal.withESCToClose)(DialogPortal);

var Dialog = (_temp2 = _class = function (_Component) {
  _inherits(Dialog, _Component);

  function Dialog() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Dialog);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Dialog.__proto__ || Object.getPrototypeOf(Dialog)).call.apply(_ref, [this].concat(args))), _this), _this.onClose = function (e) {
      _this.props.onClose(e);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Dialog, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          visible = _props.visible,
          prefix = _props.prefix,
          closeBtn = _props.closeBtn,
          style = _props.style;

      // load default max/min-width value when width is not specified in style prop

      var elStyle = _extends({}, style.width ? {} : { minWidth: '450px', maxWidth: '75%' }, style);

      // 有关闭按钮的时候同时具有ESC关闭的行为
      var PortalComponent = closeBtn ? DialogPortalESCToClose : DialogPortal;

      return _react2['default'].createElement(
        PortalComponent,
        { visible: visible, onClose: this.onClose, className: prefix + '-dialog-r-anchor' },
        _react2['default'].createElement(
          _DialogEl2['default'],
          _extends({}, this.props, { onClose: this.onClose, style: elStyle }),
          this.props.children
        )
      );
    }
  }]);

  return Dialog;
}(_react.Component), _class.propTypes = {
  prefix: _react.PropTypes.string,
  onClose: _react.PropTypes.func,
  visible: _react.PropTypes.bool,
  className: _react.PropTypes.string,
  style: _react.PropTypes.object,
  title: _react.PropTypes.node,
  closeBtn: _react.PropTypes.bool,
  mask: _react.PropTypes.bool,
  maskClosable: _react.PropTypes.bool,
  footer: _react.PropTypes.node
}, _class.defaultProps = {
  prefix: 'zent',
  onClose: function onClose() {},

  visible: false,
  className: '',
  style: {},
  title: '',
  closeBtn: true,
  mask: true,
  maskClosable: true,
  footer: null
}, _temp2);
exports['default'] = Dialog;
module.exports = exports['default'];