'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('zent-utils/classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _omit = require('zent-utils/lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Input = (_temp2 = _class = function (_Component) {
  _inherits(Input, _Component);

  function Input() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Input);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Input.__proto__ || Object.getPrototypeOf(Input)).call.apply(_ref, [this].concat(args))), _this), _this.handleKeyDown = function (evt) {
      var _this$props = _this.props,
          onKeyDown = _this$props.onKeyDown,
          onPressEnter = _this$props.onPressEnter;

      if (onPressEnter && evt.keyCode === 13) {
        onPressEnter(evt);
      }

      if (onKeyDown) onKeyDown(evt);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Input, [{
    key: 'render',
    value: function render() {
      var _classNames;

      var _props = this.props,
          addonBefore = _props.addonBefore,
          addonAfter = _props.addonAfter,
          prefix = _props.prefix,
          className = _props.className;


      var wrapClass = (0, _classnames2['default'])((_classNames = {}, _defineProperty(_classNames, prefix + '-input-wrapper', true), _defineProperty(_classNames, prefix + '-input-addons', addonAfter || addonBefore), _classNames), className);

      // 黑名单，下面这些props不应该带入到Input上
      var inputProps = (0, _omit2['default'])(this.props, ['className', 'prefix', 'addonBefore', 'addonAfter', 'onPressEnter']);

      return _react2['default'].createElement(
        'div',
        { className: wrapClass },
        addonBefore && _react2['default'].createElement(
          'span',
          { className: prefix + '-input-addon-before' },
          addonBefore
        ),
        _react2['default'].createElement('input', _extends({ className: prefix + '-input' }, inputProps, { onKeyDown: this.handleKeyDown })),
        addonAfter && _react2['default'].createElement(
          'span',
          { className: prefix + '-input-addon-after' },
          addonAfter
        )
      );
    }
  }]);

  return Input;
}(_react.Component), _class.propTypes = {
  className: _react.PropTypes.string,
  prefix: _react.PropTypes.string,
  type: _react.PropTypes.string,
  placeholder: _react.PropTypes.string,
  disabled: _react.PropTypes.bool,
  readOnly: _react.PropTypes.bool,
  value: _react.PropTypes.any,
  defaultValue: _react.PropTypes.any,
  addonBefore: _react.PropTypes.node,
  addonAfter: _react.PropTypes.node,
  onPressEnter: _react.PropTypes.func,
  onChange: _react.PropTypes.func
}, _class.defaultProps = {
  disabled: false,
  readOnly: false,
  prefix: 'zent'
}, _temp2);
exports['default'] = Input;
module.exports = exports['default'];