'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _class2, _temp2;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _zentPopover = require('zent-popover');

var _zentPopover2 = _interopRequireDefault(_zentPopover);

var _zentButton = require('zent-button');

var _zentButton2 = _interopRequireDefault(_zentButton);

var _classnames = require('zent-utils/classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _NoneTrigger = require('./NoneTrigger');

var _NoneTrigger2 = _interopRequireDefault(_NoneTrigger);

var _position = require('./position');

var _position2 = _interopRequireDefault(_position);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Trigger = _zentPopover2['default'].Trigger,
    withPopover = _zentPopover2['default'].withPopover;

var PopAction = function (_Component) {
  _inherits(PopAction, _Component);

  function PopAction() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, PopAction);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = PopAction.__proto__ || Object.getPrototypeOf(PopAction)).call.apply(_ref, [this].concat(args))), _this), _this.handleConfirm = function () {
      _this.handleClick('onConfirm');
    }, _this.handleCancel = function () {
      _this.handleClick('onCancel');
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(PopAction, [{
    key: 'handleClick',
    value: function handleClick(callbackName) {
      var _props = this.props,
          popover = _props.popover,
          trigger = _props.trigger;

      popover.close();

      var callback = this.props[callbackName];
      trigger !== 'none' && callback && callback();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          prefix = _props2.prefix,
          type = _props2.type,
          onConfirm = _props2.onConfirm,
          onCancel = _props2.onCancel,
          confirmText = _props2.confirmText,
          cancelText = _props2.cancelText;


      if (!onConfirm && !onCancel) {
        return null;
      }

      return _react2['default'].createElement(
        'div',
        { className: prefix + '-pop-buttons' },
        _react2['default'].createElement(
          _zentButton2['default'],
          { size: 'small', type: type, onClick: this.handleConfirm },
          confirmText
        ),
        _react2['default'].createElement(
          _zentButton2['default'],
          { size: 'small', onClick: this.handleCancel },
          cancelText
        )
      );
    }
  }]);

  return PopAction;
}(_react.Component);

var BoundPopAction = withPopover(PopAction);

var Pop = (_temp2 = _class2 = function (_Component2) {
  _inherits(Pop, _Component2);

  function Pop() {
    _classCallCheck(this, Pop);

    return _possibleConstructorReturn(this, (Pop.__proto__ || Object.getPrototypeOf(Pop)).apply(this, arguments));
  }

  _createClass(Pop, [{
    key: 'renderContent',
    value: function renderContent() {
      var _props3 = this.props,
          prefix = _props3.prefix,
          content = _props3.content,
          header = _props3.header,
          onConfirm = _props3.onConfirm,
          onCancel = _props3.onCancel,
          confirmText = _props3.confirmText,
          cancelText = _props3.cancelText,
          type = _props3.type;


      return _react2['default'].createElement(
        _zentPopover2['default'].Content,
        null,
        header && _react2['default'].createElement(
          'div',
          { className: prefix + '-pop-header' },
          header
        ),
        _react2['default'].createElement(
          'div',
          { className: prefix + '-pop-inner' },
          content,
          _react2['default'].createElement(BoundPopAction, {
            prefix: prefix,
            onConfirm: onConfirm,
            onCancel: onCancel,
            confirmText: confirmText,
            cancelText: cancelText,
            type: type
          })
        ),
        _react2['default'].createElement('i', { className: prefix + '-pop-arrow' })
      );
    }
  }, {
    key: 'renderTrigger',
    value: function renderTrigger() {
      var _props4 = this.props,
          trigger = _props4.trigger,
          visible = _props4.visible,
          onVisibleChange = _props4.onVisibleChange,
          closeOnClickOutside = _props4.closeOnClickOutside,
          isClickOutside = _props4.isClickOutside,
          mouseLeaveDelay = _props4.mouseLeaveDelay,
          mouseEnterDelay = _props4.mouseEnterDelay,
          children = _props4.children;


      if (trigger === 'click') {
        return _react2['default'].createElement(
          Trigger.Click,
          { autoClose: closeOnClickOutside, isOutside: isClickOutside },
          children
        );
      }

      if (trigger === 'hover') {
        return _react2['default'].createElement(
          Trigger.Hover,
          { showDelay: mouseEnterDelay, hideDelay: mouseLeaveDelay },
          children
        );
      }

      if (trigger === 'focus') {
        return _react2['default'].createElement(
          Trigger.Focus,
          null,
          children
        );
      }

      if (trigger === 'none') {
        return _react2['default'].createElement(
          _NoneTrigger2['default'],
          { visible: visible, onVisibleChange: onVisibleChange },
          children
        );
      }

      return null;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props5 = this.props,
          className = _props5.className,
          wrapperClassName = _props5.wrapperClassName,
          prefix = _props5.prefix,
          block = _props5.block,
          onShow = _props5.onShow,
          onClose = _props5.onClose,
          position = _props5.position,
          centerArrow = _props5.centerArrow;


      return _react2['default'].createElement(
        _zentPopover2['default'],
        {
          prefix: prefix,
          wrapperClassName: (0, _classnames2['default'])(prefix + '-pop-wrapper', wrapperClassName),
          className: (0, _classnames2['default'])(prefix + '-pop', className),
          cushion: 10,
          position: (0, _position2['default'])(position, centerArrow),
          display: block ? 'block' : 'inline-block',
          onShow: onShow,
          onClose: onClose
        },
        this.renderTrigger(),
        this.renderContent()
      );
    }
  }]);

  return Pop;
}(_react.Component), _class2.propTypes = {
  trigger: _react.PropTypes.oneOf(['click', 'hover', 'focus', 'none']),
  position: _react.PropTypes.oneOf(['left-top', 'left-center', 'left-bottom', 'right-top', 'right-center', 'right-bottom', 'top-left', 'top-center', 'top-right', 'bottom-left', 'bottom-center', 'bottom-right']),

  // 是否按小箭头居中对齐trigger来定位
  centerArrow: _react.PropTypes.bool,

  // trigger是否块级显示
  block: _react.PropTypes.bool,

  content: _react.PropTypes.node,
  header: _react.PropTypes.node,

  // confirm形式相关
  onConfirm: _react.PropTypes.func,
  onCancel: _react.PropTypes.func,
  confirmText: _react.PropTypes.string,
  cancelText: _react.PropTypes.string,
  type: _react.PropTypes.oneOf(['primary', 'default', 'danger', 'success']),

  // 打开之后的回掉函数
  onShow: _react.PropTypes.func,

  // 关闭之后的回掉函数
  onClose: _react.PropTypes.func,

  // 这两个只有当trigger为none时才生效
  visible: _react.PropTypes.bool,

  // 只有trigger为hover时才有效
  mouseLeaveDelay: _react.PropTypes.number,
  mouseEnterDelay: _react.PropTypes.number,

  // 只有trigger为click时才有效
  closeOnClickOutside: _react.PropTypes.bool,
  isClickOutside: _react.PropTypes.func,

  prefix: _react.PropTypes.string,
  className: _react.PropTypes.string,
  wrapperClassName: _react.PropTypes.string
}, _class2.defaultProps = {
  trigger: 'none',
  position: 'top-center',
  centerArrow: false,
  block: false,
  confirmText: '确定',
  cancelText: '取消',
  type: 'primary',
  visible: false,
  closeOnClickOutside: true,
  mouseLeaveDelay: 200,
  mouseEnterDelay: 200,
  className: '',
  wrapperClassName: '',
  prefix: 'zent'
}, _temp2);
exports['default'] = Pop;
module.exports = exports['default'];