'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('zent-utils/classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _zentPortal = require('zent-portal');

var _zentPortal2 = _interopRequireDefault(_zentPortal);

var _WindowResizeHandler = require('zent-utils/lib/component/WindowResizeHandler');

var _WindowResizeHandler2 = _interopRequireDefault(_WindowResizeHandler);

var _findPositionedParent = require('zent-utils/lib/dom/findPositionedParent');

var _findPositionedParent2 = _interopRequireDefault(_findPositionedParent);

var _throttle = require('zent-utils/lodash/throttle');

var _throttle2 = _interopRequireDefault(_throttle);

var _invisible = require('./placement/invisible');

var _invisible2 = _interopRequireDefault(_invisible);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function translateToContainerCoordinates(containerBB, bb) {
  var left = containerBB.left,
      top = containerBB.top;

  return {
    width: bb.width,
    height: bb.height,
    top: bb.top - top,
    left: bb.left - left,
    bottom: bb.bottom - top,
    right: bb.right - left
  };
}

/**
 * Like triggers, content can be replaced with your own implementation, all you have to do is extend this base class.
 *
 * The props on this class are all private.
 */
var PopoverContent = (_temp2 = _class = function (_Component) {
  _inherits(PopoverContent, _Component);

  function PopoverContent() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, PopoverContent);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = PopoverContent.__proto__ || Object.getPrototypeOf(PopoverContent)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      position: null
    }, _this.adjustPosition = function () {
      var content = _this.props.getContentNode();

      // 可能还未渲染出来，先放到一个不可见的位置
      if (!content) {
        _this.setState({
          position: (0, _invisible2['default'])(_this.props.prefix)
        });
        setTimeout(_this.adjustPosition, 0);

        return;
      }

      var anchor = _this.getAnchor();
      var boundingBox = anchor.getBoundingClientRect();

      var parent = _this.getPositionedParent();
      var parentBoundingBox = parent.getBoundingClientRect();

      var contentBoundingBox = content.getBoundingClientRect();

      var relativeBB = translateToContainerCoordinates(parentBoundingBox, boundingBox);
      var relativeContainerBB = translateToContainerCoordinates(parentBoundingBox, parentBoundingBox);
      var position = _this.props.placement(_this.props.prefix, relativeBB, relativeContainerBB, {
        width: contentBoundingBox.width,
        height: contentBoundingBox.height
      }, { cushion: _this.props.cushion });

      _this.setState({
        position: position
      });
    }, _this.onWindowResize = (0, _throttle2['default'])(function (evt, delta) {
      if (_this.props.visible && (delta.deltaX !== 0 || delta.deltaY !== 0)) {
        _this.adjustPosition();
      }
    }, 16), _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(PopoverContent, [{
    key: 'getAnchor',
    value: function getAnchor() {
      return this.props.getAnchor();
    }
  }, {
    key: 'getPositionedParent',
    value: function getPositionedParent() {
      // findPositionedParent returns null on fail
      if (this.positionedParent !== undefined) {
        return this.positionedParent;
      }

      var containerSelector = this.props.containerSelector;

      var container = document.querySelector(containerSelector);
      var parent = (0, _findPositionedParent2['default'])(container, true);
      this.positionedParent = parent;
      return parent;
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.visible && nextProps.visible !== this.props.visible) {
        this.adjustPosition();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          prefix = _props.prefix,
          className = _props.className,
          id = _props.id,
          visible = _props.visible,
          children = _props.children,
          containerSelector = _props.containerSelector;
      var position = this.state.position;


      if (!position) {
        return null;
      }

      var cls = (0, _classnames2['default'])(className, prefix + '-popover', id, position.toString());

      return _react2['default'].createElement(
        _zentPortal2['default'],
        { prefix: prefix, visible: visible, selector: containerSelector, className: cls, css: position.getCSSStyle() },
        _react2['default'].createElement(
          'div',
          { className: prefix + '-popover-content' },
          children,
          _react2['default'].createElement(_WindowResizeHandler2['default'], { onResize: this.onWindowResize })
        )
      );
    }
  }]);

  return PopoverContent;
}(_react.Component), _class.propTypes = {
  children: _react.PropTypes.node,

  prefix: _react.PropTypes.string,

  id: _react.PropTypes.string,

  getContentNode: _react.PropTypes.func,

  visible: _react.PropTypes.bool,

  // placement strategy
  placement: _react.PropTypes.func,

  cushion: _react.PropTypes.number,

  // A function that returns the anchor for this popover
  // () => Node
  getAnchor: _react.PropTypes.func,

  // defaults to body
  containerSelector: _react.PropTypes.string
}, _temp2);
exports['default'] = PopoverContent;
module.exports = exports['default'];