'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _create = require('./create');

var _create2 = _interopRequireDefault(_create);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

/**
* ----------------------
* |                    |----------
* |   anchor           | popover |
* |--------------------|---------
*
*/
exports['default'] = (0, _create2['default'])(function (anchorBoundingBox, containerBoundingBox, contentDimension, options) {
  var right = anchorBoundingBox.right,
      bottom = anchorBoundingBox.bottom;

  var x = right + options.cushion;
  var y = bottom - contentDimension.height;

  return {
    getCSSStyle: function getCSSStyle() {
      return {
        position: 'absolute',
        left: Math.round(x) + 'px',
        top: Math.round(y) + 'px'
      };
    },


    name: 'position-right-bottom'
  };
});
module.exports = exports['default'];