'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _create = require('./create');

var _create2 = _interopRequireDefault(_create);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

/**
 *        ---------
 *        |popover|
 * ----------------
 * |   anchor     |
 * |              |
 * ----------------
 */
exports['default'] = (0, _create2['default'])(function (anchorBoundingBox, containerBoundingBox, contentDimension, options) {
  var right = anchorBoundingBox.right,
      top = anchorBoundingBox.top;

  var x = right - contentDimension.width;
  var y = top - contentDimension.height - options.cushion;

  return {
    getCSSStyle: function getCSSStyle() {
      return {
        position: 'absolute',
        left: Math.round(x) + 'px',
        top: Math.round(y) + 'px'
      };
    },


    name: 'position-top-right'
  };
});
module.exports = exports['default'];