'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _react = require('react');

var _Trigger2 = require('./Trigger');

var _Trigger3 = _interopRequireDefault(_Trigger2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PopoverClickTrigger = (_temp2 = _class = function (_Trigger) {
  _inherits(PopoverClickTrigger, _Trigger);

  function PopoverClickTrigger() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, PopoverClickTrigger);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = PopoverClickTrigger.__proto__ || Object.getPrototypeOf(PopoverClickTrigger)).call.apply(_ref, [this].concat(args))), _this), _this.onClickOutside = function (evt) {
      // Optimization: skip checking if popover is hidden
      var contentVisible = _this.props.contentVisible;

      if (!contentVisible) {
        return;
      }

      var _this$props = _this.props,
          isOutside = _this$props.isOutside,
          getContentNode = _this$props.getContentNode,
          getTriggerNode = _this$props.getTriggerNode;
      var target = evt.target;

      var box = getContentNode();
      var anchor = getTriggerNode();
      if (!box.contains(target) && !anchor.contains(target) && (!isOutside || isOutside(target))) {
        _this.props.close();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(PopoverClickTrigger, [{
    key: 'getTriggerProps',
    value: function getTriggerProps(child) {
      var _this2 = this;

      return {
        onClick: function onClick(evt) {
          _this2.props.open();
          _this2.triggerEvent(child, 'onClick', evt);
        }
      };
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('click', this.onClickOutside, true);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      // bind global events only when popover is visible
      var contentVisible = nextProps.contentVisible,
          autoClose = nextProps.autoClose;

      if (contentVisible !== this.props.contentVisible) {
        if (autoClose && contentVisible) {
          return window.addEventListener('click', this.onClickOutside, true);
        }

        // Ensure handler is removed even if autoClose is false
        if (!contentVisible) {
          return window.removeEventListener('click', this.onClickOutside, true);
        }
      }
    }
  }]);

  return PopoverClickTrigger;
}(_Trigger3['default']), _class.propTypes = _extends({}, _Trigger2.PopoverTriggerPropTypes, {

  // click anywhere outside to close
  // If set to false, you have to close popover manually
  autoClose: _react.PropTypes.bool,

  // Optional click outside check
  // (target) => boolean
  isOutside: _react.PropTypes.func
}), _class.defaultProps = {
  autoClose: true
}, _temp2);
exports['default'] = PopoverClickTrigger;
module.exports = exports['default'];