'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports['default'] = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _isEqual = require('zent-utils/lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _util = require('./util');

var util = _interopRequireWildcard(_util);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DOMElement = window.Element;

/**
  Portal的核心，只负责管理child。index.js实际export的不是这个component.
**/
var Portal = (_temp = _class = function (_Component) {
  _inherits(Portal, _Component);

  function Portal() {
    _classCallCheck(this, Portal);

    return _possibleConstructorReturn(this, (Portal.__proto__ || Object.getPrototypeOf(Portal)).apply(this, arguments));
  }

  _createClass(Portal, [{
    key: 'componentDidMount',


    // openPortal和closePortal之所以不暴露出去是因为这两个API的调用容易出BUG，有操作是异步的。
    value: function componentDidMount() {
      util.openPortal.call(this);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      util.destroyPortal.call(this);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      var _this2 = this;

      if (this.pendingDestroy) {
        // destroyPortal是异步的（原因看destroyPortal的代码），所以用callback的形式调用openPortal
        util.destroyPortal.call(this, function () {
          _this2.pendingDestroy = false;
          util.openPortal.call(_this2);
        });
      } else {
        util.openPortal.call(this);
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      // 如果selector变了的话，删除再重新打开
      var selector = this.props.selector;

      if (selector !== nextProps.selector) {
        // 真正的工作是在componentDidUpdate里做的
        this.pendingDestroy = true;
        return;
      }

      // 如果children变了，直接重新render, react会判断是否有更新（即使这个是root节点）。
      // 这个也是在componentDidUpdate里做的。

      // 其它情况仅更新样式
      var _props = this.props,
          className = _props.className,
          prefix = _props.prefix,
          css = _props.css;

      if (className !== nextProps.className || prefix !== nextProps.prefix || !(0, _isEqual2['default'])(css, nextProps.css)) {
        util.prepareNode(this.node, nextProps.prefix, nextProps.className, nextProps.css);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return null;
    }
  }]);

  return Portal;
}(_react.Component), _class.propTypes = {
  children: _react.PropTypes.node.isRequired,
  selector: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.instanceOf(DOMElement)]).isRequired,
  className: _react.PropTypes.string,
  css: _react.PropTypes.object,
  prefix: _react.PropTypes.string
}, _class.defaultProps = {
  selector: 'body',
  className: '',
  css: {},
  prefix: 'zent'
}, _temp);
exports['default'] = Portal;
module.exports = exports['default'];