'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports['default'] = withNonScrollable;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
  Provides an HOC component for ensuring container is non-scrollable during component
  lifecycle.
**/
function withNonScrollable(Portal) {
  var _class, _temp;

  return _temp = _class = function (_Component) {
    _inherits(NonScrollableWrapper, _Component);

    function NonScrollableWrapper() {
      _classCallCheck(this, NonScrollableWrapper);

      return _possibleConstructorReturn(this, (NonScrollableWrapper.__proto__ || Object.getPrototypeOf(NonScrollableWrapper)).apply(this, arguments));
    }

    _createClass(NonScrollableWrapper, [{
      key: 'restoreStyle',
      value: function restoreStyle() {
        var node = (0, _util.getNodeFromSelector)(this.props.selector);
        node.style.overflow = this.originalOverflow;
      }
    }, {
      key: 'saveStyle',
      value: function saveStyle() {
        var node = (0, _util.getNodeFromSelector)(this.props.selector);
        var style = node.style;

        this.originalOverflow = style.overflow;
        style.overflow = 'hidden';
      }
    }, {
      key: 'componentDidMount',
      value: function componentDidMount() {
        if (this.props.visible) {
          this.saveStyle();
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        if (this.props.visible) {
          this.restoreStyle();
        }
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        if (this.props.visible !== nextProps.visible) {
          if (nextProps.visible === false) {
            this.restoreStyle();
          } else {
            this.saveStyle();
          }
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2['default'].createElement(Portal, this.props);
      }
    }]);

    return NonScrollableWrapper;
  }(_react.Component), _class.propTypes = {
    selector: _react.PropTypes.string
  }, _class.defaultProps = {
    selector: 'body'
  }, _temp;
}
module.exports = exports['default'];